poj 3126 Prime Path (BFS)

Prime Path
Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 14276   Accepted: 8045

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

Source

题目大意就是给两个四位的素数a,b,每次替换a的一个数位,让a变到b,但是每次替换中所生成的新四位数也必须是素数。求最少要多少步。
简单的BFS直接替换每个数位即可。
#include<cstdio>
#include<cstring>
#include<cmath>
#include<queue>
#include<iostream>
#include<algorithm>
using namespace std;
bool vis[10005];
struct node{
   int x,step;
};
node u,v;

bool prime(int u){//judge是否为素数
for(int i=2;i*i<10000;i++) if(u%i==0) return false; return true; } int bfs(int start,int end){ u.x=start; u.step=0; queue<node>q; q.push(u); memset(vis,false,sizeof(vis)); vis[start]=true; while(!q.empty()){ u=q.front(); q.pop(); if(u.x==end) return u.step; for(int i=0;i<=3;i++){ double t1=pow((double)10,i);//pow函数中的10必须转化为double型,若不转化,则会出现以下问题
//当i为2的时候结果为99,当i为4的时候结果为9999,具体原因我也不太清楚,可能是由于
//C++中对pow函数的定义为pow(double,double),如果强加用int可能会有精度损失
int x=(u.x/(int)t1)%10; for(int j=0;j<=9;j++){ if(j==0&&i==3)//最高位不可以为0continue; int temp2=u.x+(j-x)*t1;//获得下一个数 if(prime(temp2)&&!vis[temp2]){//如果下一个数不为素数并且没有别访问过 vis[temp2]=true; v.step=u.step+1; v.x=temp2; q.push(v); } } } } return -1; } int main(){ int t; scanf("%d",&t); while(t--){ int start,end; scanf("%d%d",&start,&end); int ans=bfs(start,end); if(ans==-1) printf("Impossible\n"); else printf("%d\n",ans); } return 0; }

 

posted @ 2015-08-19 10:24  柳下_MBX  阅读(162)  评论(0编辑  收藏  举报